program pswitch;

{$R *.res}

uses
  Windows, Messages, IniFiles, SysUtils, Registry;

var
  Ini: TIniFile;
  Profile: Integer;
  acpower: Boolean;
  SysPowerStatus: TSystemPowerStatus;
  OurTick, TickId: Integer;
  SleepLength: Integer;

function PostAtkOsdMessage(ImageSet, ImageIndex: Word): Boolean;
var
  hWnd: LongWord;
  wParam: Integer;
begin
  Result := False;
  hWnd := FindWindow('ATKOSD', 'ATKOSD');
  if hWnd = 0 then Exit;

  if ImageSet in [92, 108] then
    wParam := ImageIndex shl 16 + ImageSet
  else
    wParam := ImageIndex;

  if not PostMessage(hWnd, WM_COMMAND, wParam, 0) then Exit;
  Result := True;
end;

function PostRMClockMessage(ProfileIndex: Word): Boolean;
var
  hWnd: LongWord;
  wParam: Integer;
begin
  Result := False;
  if not (ProfileIndex in [0..3]) then Exit;
  hWnd := FindWindow('#32770','RightMark CPU Clock Utility');
  if hWnd = 0 then Exit;

  // RMClock v2.05 = $8004, v2.1 = $800E
  wParam := ProfileIndex + Ini.ReadInteger('Main', 'RMClockBase', $800E);
  if not PostMessage(hWnd, WM_COMMAND, wParam, 0) then Exit;
  Result := True;
end;

function SetATIProfile(ProfileName: string): Boolean;
var
  Path, CmdLine: string;
  StartInfo: TStartupInfo;
  ProcInfo: TProcessInformation;
  Ver :integer;
begin
  Result := False;
  Ver := 0;
  with TRegistry.Create do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\Software\ATI\ACE', False);
    if ValueExists('Path') then
      begin
        Path := ReadString('Path');
      end
    else
      begin
        OpenKey('\Software\ATI', False);
        Path := ReadString('Path');
        Ver := 1;
      end;
    Free;
  end;

  case Ver of
    0:
      begin
        if Path = '' then Path := 'c:\Program Files\ATI Technologies\ATI.ACE\';
        CmdLine := Format('%sCLI.exe Load profilename="%s"', [Path, ProfileName]);
      end;
    1:
      begin 
        if Path = '' then Path := 'C:\Program Files\ATI Technologies\ATI.ACE\Core-Static';
        CmdLine := Format('%s\CLI.exe Start Load profilename="%s"', [Path, ProfileName]);
      end;
  end;

  FillChar(StartInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcInfo,SizeOf(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);

  if CreateProcess(nil, PChar(CmdLine), nil, nil, False,
    CREATE_NEW_PROCESS_GROUP + NORMAL_PRIORITY_CLASS, nil, nil,
    StartInfo, ProcInfo) then
  begin
    WaitForSingleObject(ProcInfo.hProcess, 1000);
    Result := True;
  end;
end;



procedure ActivateProfile;
begin
  if Ini.ReadBool('Main', 'RMClock', False) then
    PostRMClockMessage(Ini.ReadInteger(IntToStr(Profile), 'RMClockProfile', 0));

  if Ini.ReadBool('Main', 'AtiCatalyst', False) then
    SetATIProfile(Ini.ReadString(IntToStr(Profile), 'AtiCatalystProfile', ''));
end;

procedure ShowOsd;
begin
  if Ini.ReadBool('Main', 'ShowAtkOsd', False) then
    PostAtkOsdMessage(Ini.ReadInteger(IntToStr(Profile), 'AtkOsdImageSet', 0),
                      Ini.ReadInteger(IntToStr(Profile), 'AtkOsdImageIndex', 0));
end;



begin
  Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'pswitch.ini');
  try
    try
      OurTick := GetTickCount;
      
      // Zjistime jestli je NB napajen ze site, nebo z baterie
      GetSystemPowerStatus(SysPowerStatus);
      acpower := SysPowerStatus.ACLineStatus = 1;

      // aktivuje nasledujici profil
      if (LowerCase(ParamStr(1)) = 'next') and (ParamCount = 1) then begin
        if acpower then Profile := Ini.ReadInteger('System', 'CurrentProfileAC', 0)
                   else Profile := Ini.ReadInteger('System', 'CurrentProfileBatt', 0);

        TickId := Ini.ReadInteger('System', 'TickId', 0);
        SleepLength := Ini.ReadInteger('Main', 'Delay', 2200);

        if ((TickId > OurTick) or (OurTick - TickId > SleepLength))
           and (Ini.ReadBool('Main', 'ShowBeforeSwitch', False)) then
        begin
          // pokud je cas prilis vysoky nebo delsi nez 2.2s a zaroven zapnute ShowBeforeSwitch
          // nemenit profil - jen ukazat a reaktivovat
        end else begin
          // jinak zvysit
          Inc(Profile);
        end;

        if Profile >= Ini.ReadInteger('Main', 'ProfileCount', 1) then Profile := 0;
        if acpower then Ini.WriteInteger('System', 'CurrentProfileAC', Profile)
                   else Ini.WriteInteger('System', 'CurrentProfileBatt', Profile);

        // zapiseme si do ini souboru identifikator naseho procesu
        Ini.WriteInteger('System', 'TickId', OurTick);

        ShowOsd;
        Sleep(SleepLength);

        if Ini.ReadInteger('System', 'TickId', 0) = OurTick then begin
          // Not overrided, activating profile
          ActivateProfile;
        end else begin
          // Overrided, exiting
        end;
      end

      // reaktivuje aktualni profil
      else if (LowerCase(ParamStr(1)) = 'current') and (ParamCount = 1) then begin
        if acpower then Profile := Ini.ReadInteger('System', 'CurrentProfileAC', 0)
                   else Profile := Ini.ReadInteger('System', 'CurrentProfileBatt', 0);
        ShowOsd;
        ActivateProfile;
      end

      // aktivuje profil zadany parametrem
      else if (LowerCase(ParamStr(1)) = 'profile') and (ParamCount = 2) then begin
        Profile := StrToInt(ParamStr(1));
        if acpower then Ini.WriteInteger('System', 'CurrentProfileAC', Profile)
                   else Ini.WriteInteger('System', 'CurrentProfileBatt', Profile);
        ShowOsd;
        ActivateProfile;
      end

      // zobrazi OSD aktualniho profilu
      else if (LowerCase(ParamStr(1)) = 'show') and (ParamCount = 1) then begin
        if acpower then Profile := Ini.ReadInteger('System', 'CurrentProfileAC', 0)
                   else Profile := Ini.ReadInteger('System', 'CurrentProfileBatt', 0);
        ShowOsd;
      end

      // pouze zobrazi osd
      else if (LowerCase(ParamStr(1)) = 'osd') and (ParamCount = 3) then begin
        PostAtkOsdMessage(StrToInt(ParamStr(2)), StrToInt(ParamStr(3)));
      end

      // jinak zobrazi napovedu, stejne jako pri chybe
      else Abort;
    except
      MessageBox(0, 'Usage:'#13#10#13#10 +
                    'pswitch current ... reactivate current profile'#13#10 +
                    'pswitch next ... activate next profile'#13#10 +
                    'pswitch profile profile_index ... activate specified profile'#13#10 +
                    'pswitch osd image_set image_index ... shows specified AtkOsd'#13#10 +
                    'pswitch show ... shows current profile',
                    nil, MB_OK + MB_ICONERROR);
      Exit;
    end;
  finally
    Ini.Free;
  end;
end.
